




/* Code from David Eyerman's Eyefract v0.5.6:
 *   - struct describing a complex number
 *   - struct describing a fractal image state
 *
 */


/*  complext number: a + bi  */

#ifdef USE_C_PLUS_PLUS
class complex {
 public:

#else
struct complex {

#endif

    double a;
    double b;

};




/*  a "state" structure containing vital information
 *  for quickly re-producing a picture 
 */

#ifdef USE_C_PLUS_PLUS
class state {
 public:

#else
struct state {

#endif
   
    struct state *next, *prev;
    double xmin, xmax, ymin, ymax;  /* Cartesian coordinates */
    int MAXITS;                     /* the number of iterations before we "give up"  */
    int width;  int height;         /* dimensions of pixmap, drawing area */
    int pwidth; int pheight;        /* dimensions of preview pixmap, preview drawing area */
    int depth;                      /* COLOR or BW */
//    XColor colors[NUM_COLORS];      /* colormap */
    int type;                       /* JULIA or MANDELBROT */
    int func_idx;                   /* which function in the array this was generated with */

#ifdef USE_C_PLUS_PLUS
    complex subA;
#else
    struct complex subA;            /* the complex parameter */
#endif

 //   Pixmap pix;                     /* the picture of the state */
 //   Pixmap preview;                 /* thumbnail version */
};




#ifdef USE_C_PLUS_PLUS
state *curState; 
#else
struct state *curState;
#endif


