/* Jim Susinno - glf_mouse.c
 *  #included from glfract.c
 *
 *   from glfract v0.0.9 : Julia param sliding
 *    threshold(like x,y).
 */




/* Mouse Input Handler
 *   
 *
 */
void MouseInputHandler( int button, int state, int x, int y ) {
  which_button = button;

  /*** initiate drag = set old and new mouse value to click pt. ***/
  if ( state == GLUT_DOWN ) { 
    last_click_x = x;
    last_click_y = y;
    mouse_button_down = 1;
  }

  /*** mouse up - cancel all drags ***/
  else if ( state == GLUT_UP ) { 
    mouse_button_down = 0;
  }

  /*** update last values to know mouse motion ***/
  oldx = newx = x;
  oldy = newy = y;

  glutPostRedisplay();
}



/* Handles mouse motion -
 *   uses change in x,y location to induce 
 *   parameter change(camera. light, view)
 *
 */
void MouseMoveHandler( int x, int y ) {
  float threshold = 0.35;
  int the_button = -1;

  oldx = newx;
  oldy = newy;
  newx = x;
  newy = y;

  /*** mosh v0.2.1 - new mouse handler code ***/
  if ( which_button == GLUT_LEFT_BUTTON ) {
    the_button = 0;
  }
  else if ( which_button == GLUT_MIDDLE_BUTTON ) {
    the_button = 1;
  }
  else if ( which_button == GLUT_RIGHT_BUTTON ) {
    the_button = 2;
  }


  /*** adjust threshold for xy-min changing ***/
  if ( mouseb[the_button] == 4 ) {

    /*** flip for intuitive control ***/
    if ( live_update ) { threshold *= -1.0; }

    threshold *= 0.05;
    threshold *= zoom_params[1][current_cache] - zoom_params[0][current_cache];
  }



  /*** variable zoom threshold ***/
  if ( ( mouseb[the_button] == 5 ) || ( mouseb[the_button] == 6 ) ) {
    threshold *= 0.05;
    /*** sensitive complex Julia param(a,b) changing ***/
    if ( mouseb[the_button] == 6 ) { threshold *= 0.02; }

    if ( mouse_flts[5][0] < 1.0 ) {
      threshold /= zoom_params[1][current_cache] - zoom_params[0][current_cache];
    }
    else {
      threshold *= zoom_params[1][current_cache] - zoom_params[0][current_cache];
    }
  }


 

  /*** update motion if valid button is down ***/
  if ( the_button > -1 ) {

    if ( fabs( mouse_flts[ mouseb[the_button] ][0] + 
	       threshold*(float)(x-oldx)) < 30000000.0 ) {
      mouse_flts[ mouseb[the_button] ][0] += threshold*(float)(x-oldx);
    }

    if ( fabs( mouse_flts[ mouseb[the_button] ][1] + 
	       threshold*(float)(y-oldy)) < 30000000.0 ) {
      mouse_flts[ mouseb[the_button] ][1] += threshold*(float)(y-oldy);
    }

  }


  glutPostRedisplay();
}




